
/*
 * onsuccess returns true  - connection is restarted immediately
 * onsuccess returns false - connection is started after interval
 */
var LongPollConnection = function() {
    //--- CONF
    defaults = {
        path : 'listen'
    };
    
    var TimeoutInterval = {
        offline : 3,
        online : 120
    }
    var interval = TimeoutInterval.online;
    var isOffline = false;
    
    //--- DATA
    var lastUpdated = (new Date).getTime();
    
    var queue = [];

    var xhr = {abort : function() {}, readyState : 2};
    var to;
    // TODO: ADD QUE 
    function startAndKeep(path, body) {
        //path = path || defaults.path;
        //body = body || null;
        
        // if it's default 'listen' polling
        // then don't add it to the queue...
        if (arguments.length == 0) {
            // ... unless the queue is empty
            if (queue.length == 0) {
                queue.push({
                    path : defaults.path,
                    body : null
                });
            }
        }
        else {
            queue.push({
                path : path,
                body : body
            });
        }
        
        // if to or from proccessing is finished
        // and neither to nor from sending has begun - abort
        if (xhr.readyState == 2 || xhr.readyState == 4) {
            stop();
        }
        else {
            // return for now, when present connection is done
            // it'll restart automatically
            return;
        }
        
        var req = queue.shift();
        //opera.postError('requesting ' + req.path);
        // send new
        xhr = sendRequest({
            path : req.path,
            body : req.body,
            headers : {
                'X-Last-updated' : lastUpdated
            },
            onsuccess : function(xHttpReq)
            {
                if (isOffline)
                {
                    try
                    {
                        if (ResponseHandler["onserverup"])
                        {
                            ResponseHandler["onserverup"].apply(ResponseHandler, null);
                        }
                    }
                    finally
                    {
                        interval = TimeoutInterval.online;
                        isOffline = false;
                    }
                }
                var action = xHttpReq.getResponseHeader('X-Action');
                //opera.postError("Action  = " + action);
                var lu = parseInt(xHttpReq.getResponseHeader('X-Updating-to'));
                if (!isNaN(lu)) {lastUpdated = lu;}
//opera.postError('GOT '+ xHttpReq.responseText);
                if (
                    !(action && action in ResponseHandler)
                    || ResponseHandler[action](xHttpReq)
                ) {
                    startAndKeep();
                };
            },
            onerror : function(xHttpReq) {
                //
                if (404 == xHttpReq.status)
                {
                    if (! isOffline)
                    {
                        try
                        {
                            if (ResponseHandler["onserverdown"])
                            {
                                ResponseHandler["onserverdown"].apply(ResponseHandler, null);
                            }
                        }
                        finally
                        {
                            interval = TimeoutInterval.offline;
                            isOffline = true;
                            queue.unshift(req);
                            clearInterval(to);
                            startAndKeep();
                        }
                    }
                }   
            },
            '0' : function()
            {
                //opera.postError('Spec violation!');
            }
        });
        
        to = setTimeout(startAndKeep, interval * 1000)
    };
    
    function stop() {
        xhr.abort();
        clearTimeout(to);
    }
    
    this.startAndKeep = startAndKeep;
    this.stop = stop;
    
};
