function sendRequest(xhrData) {

    var xhrData = xhrData || {};
    var path = xhrData.path || '';
    var body = xhrData.body || '';
//opera.postError('--- XHR: '+path);
    var that = xhrData.self || null;
    
    var keep = xhrData.keep || false;
    
    var headers = xhrData.headers || {};
    
    var dfltHeaders = {
        "Content-Type" : 'application/x-www-form-urlencoded; charset=utf-8',
        "Cache-Control" : 'no-cache'
    };
    
    for (header in dfltHeaders) {
        if (!(header in headers)) {
            headers[header] = dfltHeaders[header];
        }
    }

    var onsuccess = typeof xhrData.onsuccess === 'function' ? xhrData.onsuccess : function() {};
    var onerror = typeof xhrData.onerror === 'function' ? xhrData.onerror : function() {};
    var ondone = typeof xhrData.ondone === 'function' ? xhrData.ondone : function() {};
    
    if (xhrData.method == 'get' || xhrData.method == 'GET') {
        path += '?'+body;
        body = null;
    }    
    var method = xhrData.method || (body ? 'post' : 'get');
    
    var async = (typeof xhrData.async !== 'undefined')
        ? xhrData.async : true;
    
    var xhr = new XMLHttpRequest();
    
    var to;
    xhr.onreadystatechange = function() {
        if (keep) {
            if (this.readyState == 2) {
                var self = this;
                to = setTimeout(function() {
                    self.abort();   // calls onerror...
                    //opera.postError('no way '+ to + ' ' + path);
                    ondone.call(that, this);
                }, keep * 1000)
            }
            else if (this.readyState > 2) {
                clearTimeout(to);
            }
        }
        if (this.readyState == 4) {
           //opera.postError('@'+this.status + ' ' + path);
            if (this.status in xhrData) {
                xhrData[this.status].call(that, this);
            }
            else if (this.status == 200) {
                onsuccess.call(that, this);
            } else { //if (this.status != 0) {
                onerror.call(that, this);
            }
            ondone.call(that, this);
        }
    };

    // don't cach
    // var sign = !~path.indexOf('?') ? '?' : '&';
    // path += sign+'nocache='+(new Date).valueOf();
    xhr.open(method, path, async);

    for (h in headers) {xhr.setRequestHeader(h, headers[h]);}

    // try {
    xhr.send(body);
    // } catch(e) { onerror.call(that, xhr) }
    return xhr;
};
