var FocusBlurNotifier = new function()
{
    this._notifyDelta = 5000; 
    this._timeoutId = 0;
    this._isFocused = true;
    this._lastStateSent = null;
    
    this._clearNotification = function()
    {
        if (FocusBlurNotifier._timeoutId > 0)
        {
            clearTimeout(FocusBlurNotifier._timeoutId);
            FocusBlurNotifier._timeoutId = 0;
        }
    }
    
    this._notifyStateChange = function()
    {
        if (FocusBlurNotifier._lastStateSent != FocusBlurNotifier._isFocused)
        {
            FocusBlurNotifier._clearNotification();
            //>opera.postError("sending focus state " + FocusBlurNotifier._isFocused);
            ViewCtrl.connection.startAndKeep('focusstate', 'focusstate=' + FocusBlurNotifier._isFocused);
            FocusBlurNotifier._lastStateSent = FocusBlurNotifier._isFocused;
        }
    }
    
    this._queNotifyStateChange = function()
    {
        if (FocusBlurNotifier._timeoutId > 0)
        {
            FocusBlurNotifier._clearNotification();
        }
        FocusBlurNotifier._timeoutId = setTimeout(FocusBlurNotifier._notifyStateChange, FocusBlurNotifier._notifyDelta);
    }
    
    this.onWindowFocus = function()
    {
        if (false == FocusBlurNotifier._isFocused || FocusBlurNotifier._isFocused == null)
        {
            FocusBlurNotifier._queNotifyStateChange();
            FocusBlurNotifier._isFocused = true;
        }
    }
    
    this.onWindowBlur = function()
    {
        if (true == FocusBlurNotifier._isFocused || FocusBlurNotifier._isFocused == null)
        {
            FocusBlurNotifier._queNotifyStateChange();
            FocusBlurNotifier._isFocused = false;
        }
    }
    
    this.init = function()
    {
        window.addEventListener("focus", this.onWindowFocus, false);
        window.addEventListener("blur", this.onWindowBlur, false);
        setTimeout(this._queNotifyStateChange, 500);
    }
    
    this.init();
}