ResponseHandler = {
    friends : function(xhr) {
        var form = document.forms.friends_form;
      
        var friends = JSON.parse(xhr.responseText);
        
        ViewCtrl.onFriendsReceived(friends);
        
        return true;
    },
    // note that there is no known order so sorting is needed
    chat : function(xhr) {
        var posts = [];
        try
        {
            var posts = JSON.parse(xhr.responseText);
            Dbg.inspect(posts, "Posts: ");
        }
        catch (ex)
        {
            Dbg.inspect("Exception from JSON: " + xhr.responsetext);
        }
        
        var seenUser = {};
        var updatedUsers = [];

        // scream for refactoring
        for (var i = 0; i < posts.length; i++)
        {
            var post = posts[i];

            if ("deleted" == post.state)
            {
                MessageCtrl.deletePendingMessage(post);
            }
            else 
            {
                MessageData.addMessage(post);
            }
            
            //Dbg.inspect(post, "Got chat req");
            if (! seenUser[post.sender])
            {
                seenUser[post.sender] = true;
                updatedUsers.push(post.sender);
            }
            
            if (! seenUser[post.recipient])
            {
                seenUser[post.recipient] = true;
                updatedUsers.push(post.recipient);
            }
        }

        ViewCtrl.refreshUsers(updatedUsers);
        
        return true;
    },
    conversations : function(xhr)
    {
        var conversations = JSON.parse(xhr.responseText);
        Dbg.inspect(conversations, "Conversations: ");
        for (var i = 0; i < conversations.length; i++)
        {
            var post = conversations[i];
            
            MessageData.addMessage(post);
        }
        
        return true;
    },
    onserverdown : function()
    {
        ViewCtrl.displayAlertScreen();
    },
    onserverup : function()
    {
        ViewCtrl.hideAlertScreen();
    },
    currentuser : function(xhr)
    {
        var username = xhr.responseXML.getElementsByTagName("user")[0].textContent;
        
        if (username != undefined && username != "")
        {
            location.hash = "#" + username;
            if (username != ViewState.CurrentSelectedUser)
            {
                MessageCtrl.onUserSelected(username);
            }
        }
        else
        {
            $("message-filter").style.display = "none";
            $("start-help").style.display = "block";                   
        }
        
        
        
        return true;
    }
};

var g_startScreenIntervalId = 0;
var g_numStartScreenTries = 0;

onload = function() {
    var connection = new LongPollConnection();
    
    var addForm = document.forms.add_form;
    var sendForm = document.forms.send_form;
    
    ViewCtrl.init(connection);
    
    $("contacts").addEventListener("click", ViewCtrl.onContactsClicked, false);
    
    if (!Config.seenFriends)
    {
        $("import-friends").style.display = "block";
    }
    
    function setStartScreen()
    {
        // If no friends are loaded, but we have seen friends sometimes earlier,
        // try to requery for friends.
        if (! ContactsCtrl.hasContacts() && Config.seenFriends)
        {
            if (g_numStartScreenTries > 1)
            {
                ViewCtrl.displayEmptyScreen();
            }
            
            connection.startAndKeep('friendsshow', null);
            connection.startAndKeep('currentuser', null);
        }
        
        if (! ContactsCtrl.hasContacts())
        {
            if (g_numStartScreenTries++ > 8)
            {
                ViewCtrl.displayNoUsersScreen();
                clearInterval(g_startScreenIntervalId);
            }
        }
        else    
        {
            clearInterval(g_startScreenIntervalId);
            ViewCtrl.displayNormalScreen();
        }
    }    
    
   g_startScreenIntervalId = setInterval(setStartScreen, 500);
};
